From 749afdc3cfe781f785c95501aa58472c78b71bf7 Mon Sep 17 00:00:00 2001
From: kobarity <kobarity@gmail.com>
Date: Mon, 22 May 2023 00:01:16 +0900
Subject: [PATCH] Optimize python-info-docstring-p

* lisp/progmodes/python.el (python-info-docstring-p): Add condition
that is not inside paren except for "(".  (Bug#63622)
---
 lisp/progmodes/python.el | 3 +++
 1 file changed, 3 insertions(+)

diff --git a/lisp/progmodes/python.el b/lisp/progmodes/python.el
index 6fc05b246a6..af48d852182 100644
--- a/lisp/progmodes/python.el
+++ b/lisp/progmodes/python.el
@@ -6021,6 +6021,9 @@ python-info-docstring-p
           (re (concat "[uU]?[rR]?"
                       (python-rx string-delimiter))))
       (when (and
+             (not (and syntax-ppss
+                       (when-let ((pos (nth 1 syntax-ppss)))
+                         (/= (char-after pos) ?\())))
              (not (python-info-assignment-statement-p))
              (looking-at-p re)
              ;; Allow up to two consecutive docstrings only.
-- 
2.34.1

